from micrograd.nn import MLP

def model():
    n = MLP(3, [4, 4, 1])
    xs = [
        [2.0,  3.0, -1.0],
        [3.0, -1.0,  0.5],
        [0.5,  1.0,  1.0],
        [1.0,  1.0,  1.0],
    ]
    y_true = [1.0, -1.0, -1.0, 1.0]
    epochs = 20
    lr = 0.08
    for epoch in range(epochs):


        # forward
        y_pred = [n(x) for x in xs]
        loss = sum([(y_p - y_t)**2 for y_p, y_t in zip(y_pred, y_true)])

        # backward
        for p in n.parameters():
            p.grad = 0.0
        loss.backward()

        # update
        for p in n.parameters():
            p.data += -lr * p.grad

        print(f"{epoch=:02d} | loss: {loss.data:4f}")
    print(f"{[y.data for y in y_pred]}")
    print(f"{[y for y in y_true]}")
    return n

if __name__ == "__main__":
    model()
